博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
POJ 3126:Prime Path(素数+BFS)
阅读量:4697 次
发布时间:2019-06-09

本文共 3334 字,大约阅读时间需要 11 分钟。

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 103310331033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 817981798179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 888, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 103310331033 to 817981798179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733
3733
3739
3779
8779
8179

The cost of this solution is 666 pounds. Note that the digit 111 which got pasted over in step 222 can not be reused in the last step – a new 111 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100100100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Examples

Input

31033 81791373 80171033 1033

Output

670

题意

给出两个四位的素数n,mn,mn,m,要求nnn每次只能变换一位,并且变换后的数字依旧是素数。

nnn经过多少步变换能够变成mmm;如果nnn无法变成mmm,输出Impossible

思路

nnn的四位数字拆分了,每次变换一位,来判断是否符合条件,如果符合条件,将新数字加入队列,至到数字和mmm相等,或队列为空

AC代码

#include 
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#define ll long long#define ull unsigned long long#define ms(a,b) memset(a,b,sizeof(a))#define pi acos(-1.0)#define INF 0x7f7f7f7f#define lson o<<1#define rson o<<1|1#define bug cout<<"-------------"<
que; p.num=n; p.step=0; que.push(p); _vis[n]=1; while(!que.empty()) { q=que.front(); que.pop(); if(q.num==m) return q.step; int get[4]; int N=q.num; int _=0; while(N) { get[_++]=N%10; N/=10; } for(int i=0;i<4;i++) { int __=get[i]; for(int j=0;j<=9;j++) { if(get[i]!=j) { get[i]=j; newnum=get[0]+get[1]*10+get[2]*100+get[3]*1000; } if(!vis[newnum]&&newnum>=1000&&newnum<10000&&!_vis[newnum]) { p.num=newnum; p.step=q.step+1; _vis[newnum]=1; que.push(p); } } get[i]=__; } } return -1;}void init(){ vis[0]=vis[1]=1; for(int i=2;i
>t; while(t--) { int n,m; cin>>n>>m; int ans=bfs(n,m); if(ans==-1) cout<<"Impossible"<

转载于:https://www.cnblogs.com/Friends-A/p/11054980.html

你可能感兴趣的文章
unity编辑器学习,创建自己的窗口
查看>>
Microsoft Build 2015
查看>>
使用EntityFrameWork 5.0增删查改(&分页,连表)
查看>>
ios block常见的错误(三)——并发编程的block引用
查看>>
Arcgis Server发布的带有透明度的地图服务,调用时不显示透明度问题
查看>>
Android Loader详解(官方文档翻译)
查看>>
[Java]ArrayList源码分析
查看>>
Mybatis中javaType和jdbcType对应关系
查看>>
Master Concept provides Professional Service for server and storage virtualization.
查看>>
客户端javascript笔记
查看>>
工作笔记——前端分页数据回显
查看>>
test小结
查看>>
Apache 调用不同的 PHP 版本
查看>>
第三周总结
查看>>
流程控制与数组
查看>>
python循环导入的解决方案
查看>>
AngularJS中选择样式
查看>>
JDK的命令具体解释操作
查看>>
创建图书管理项目
查看>>
ie6 双边距问题
查看>>